diff --git a/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALDeco.java b/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALDeco.java
index 9519128..e553b1d 100644
--- a/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALDeco.java
+++ b/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALDeco.java
@@ -51,7 +51,7 @@ import com.cloudera.flume.handlers.rolling.SizeTrigger;
 import com.cloudera.flume.handlers.rolling.TimeTrigger;
 import com.cloudera.flume.reporter.ReportManager;
 import com.cloudera.flume.reporter.aggregator.CounterSink;
-import com.cloudera.util.BenchmarkHarness;
+import com.cloudera.util.FlumeTestHarness;
 import com.cloudera.util.FileUtil;
 
 /**
@@ -74,14 +74,14 @@ public class TestNaiveFileWALDeco {
   public void testRecoveredIsDeleted() throws IOException, FlumeSpecException,
       InterruptedException {
 
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     // file with ack begin, data, and end messages
     File acked = new File("src/data/acked.00000000.20100204-015814430-0800.seq");
     // Assumes the NaiveFileWALManager!
     File writing = new File(new File(tmp,
-        BenchmarkHarness.node.getPhysicalNodeName()), "writing");
+        FlumeTestHarness.node.getPhysicalNodeName()), "writing");
     writing.mkdirs();
 
     // Must rename file because that name is in the meta data of the event
@@ -103,7 +103,7 @@ public class TestNaiveFileWALDeco {
     snk.close(); // this should block until recovery complete.
 
     // agent checks for ack registrations.
-    BenchmarkHarness.node.getAckChecker().checkAcks();
+    FlumeTestHarness.node.getAckChecker().checkAcks();
 
     CounterSink cnt = (CounterSink) ReportManager.get().getReportable("count");
     // 1032 in file + 5 from silly driver
@@ -118,7 +118,7 @@ public class TestNaiveFileWALDeco {
     assertFalse(new File(new File(tmp, "error"), acked.getName()).exists());
     assertFalse(new File(new File(tmp, "done"), acked.getName()).exists());
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
@@ -131,14 +131,14 @@ public class TestNaiveFileWALDeco {
       FlumeSpecException, InterruptedException {
     // FlumeConfiguration.get().setLong(FlumeConfiguration.AGENT_LOG_MAX_AGE,
     // 50);
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     // file with ack begin, data, and end messages
     File acked = new File("src/data/acked.00000000.20100204-015814430-0800.seq");
     // Assumes the NaiveFileWALManager!
     File writing = new File(new File(tmp,
-        BenchmarkHarness.node.getPhysicalNodeName()), "writing");
+        FlumeTestHarness.node.getPhysicalNodeName()), "writing");
     writing.mkdirs();
 
     // /////////////////////
@@ -157,7 +157,7 @@ public class TestNaiveFileWALDeco {
     snk.close(); // this should block until recovery complete.
 
     // agent checks for ack registrations.
-    BenchmarkHarness.node.getAckChecker().checkAcks();
+    FlumeTestHarness.node.getAckChecker().checkAcks();
 
     CounterSink cnt = (CounterSink) ReportManager.get().getReportable("count");
     // 1032 in file + 5 from silly driverx
@@ -175,10 +175,10 @@ public class TestNaiveFileWALDeco {
     // locally is reasonable for now.
 
     assertTrue(new File(new File(new File(tmp,
-        BenchmarkHarness.node.getPhysicalNodeName()), "sent"), acked.getName())
+        FlumeTestHarness.node.getPhysicalNodeName()), "sent"), acked.getName())
         .exists());
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
@@ -193,15 +193,15 @@ public class TestNaiveFileWALDeco {
   @Test
   public void testRecoveredMovesToErr() throws IOException, FlumeSpecException,
       InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     // Assumes the NaiveFileWALManager!
     // file with ack begin, data and then truncated
     File truncated = new File(
         "src/data/truncated.00000000.20100204-015814430-0800.seq");
     File writing = new File(new File(tmp,
-        BenchmarkHarness.node.getPhysicalNodeName()), "writing");
+        FlumeTestHarness.node.getPhysicalNodeName()), "writing");
 
     writing.mkdirs();
     FileUtil.dumbfilecopy(truncated, new File(writing, truncated.getName()));
@@ -225,7 +225,7 @@ public class TestNaiveFileWALDeco {
     // BenchmarkHarness.mock.ackman.;
 
     // check to make sure wal file is gone
-    File nodedir = new File(tmp, BenchmarkHarness.node.getPhysicalNodeName());
+    File nodedir = new File(tmp, FlumeTestHarness.node.getPhysicalNodeName());
 
     assertFalse(new File(new File(nodedir, "import"), truncated.getName())
         .exists());
@@ -245,7 +245,7 @@ public class TestNaiveFileWALDeco {
     assertFalse(new File(new File(nodedir, "done"), truncated.getName())
         .exists());
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
@@ -316,7 +316,7 @@ public class TestNaiveFileWALDeco {
   public void testExceptionThreadHandoff() throws IOException,
       InterruptedException {
     try {
-      BenchmarkHarness.setupLocalWriteDir();
+      FlumeTestHarness.setupLocalWriteDir();
       Event e = new EventImpl(new byte[0]);
       EventSink snk = new EventSink.Base() {
         @Override
@@ -337,7 +337,7 @@ public class TestNaiveFileWALDeco {
     } catch (IOException e) {
       throw e;
     } finally {
-      BenchmarkHarness.cleanupLocalWriteDir();
+      FlumeTestHarness.cleanupLocalWriteDir();
     }
   }
 
diff --git a/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALHandles.java b/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALHandles.java
index 83fe7da..b5fc0be 100644
--- a/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALHandles.java
+++ b/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALHandles.java
@@ -28,7 +28,7 @@ import com.cloudera.flume.core.Event;
 import com.cloudera.flume.core.EventImpl;
 import com.cloudera.flume.core.EventSink;
 import com.cloudera.flume.handlers.hdfs.SeqfileEventSink;
-import com.cloudera.util.BenchmarkHarness;
+import com.cloudera.util.FlumeTestHarness;
 
 /**
  * Test for file handle exhaustion problems with WAL and DFO
@@ -45,8 +45,8 @@ public class TestNaiveFileWALHandles {
    */
   @Test
   public void testSeqfileEventSinkHandleExhaust() throws IOException, InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     for (int i = 0; i < 3000; i++) {
       File path = new File(tmp, "" + i);
diff --git a/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALManager.java b/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALManager.java
index e82efb8..2a16083 100644
--- a/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALManager.java
+++ b/src/javatest/com/cloudera/flume/agent/durability/TestNaiveFileWALManager.java
@@ -38,7 +38,7 @@ import com.cloudera.flume.handlers.endtoend.AckChecksumInjector;
 import com.cloudera.flume.handlers.hdfs.SeqfileEventSink;
 import com.cloudera.flume.handlers.rolling.ProcessTagger;
 import com.cloudera.flume.handlers.rolling.Tagger;
-import com.cloudera.util.BenchmarkHarness;
+import com.cloudera.util.FlumeTestHarness;
 import com.cloudera.util.FileUtil;
 
 public class TestNaiveFileWALManager {
@@ -136,8 +136,8 @@ public class TestNaiveFileWALManager {
    */
   @Test
   public void testRecovers() throws IOException, FlumeSpecException {
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     // putting in large ridiculous constant
     NaiveFileWALManager wal = new NaiveFileWALManager(tmp);
@@ -171,7 +171,7 @@ public class TestNaiveFileWALManager {
     // logged, writing, sending, sent
     assertEquals(4, new File(tmp, "logged").list().length);
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
@@ -181,8 +181,8 @@ public class TestNaiveFileWALManager {
   @Test
   public void testReframeRecovers() throws IOException, FlumeSpecException,
       InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     NaiveFileWALManager wal = new NaiveFileWALManager(tmp);
     wal.open(); // create dirs
@@ -211,7 +211,7 @@ public class TestNaiveFileWALManager {
     assertEquals(1, new File(tmp, "error").list().length);
     assertEquals(1, new File(tmp, "logged").list().length);
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
@@ -220,8 +220,8 @@ public class TestNaiveFileWALManager {
   @Test
   public void testReframeMultipleOpenAcks() throws IOException,
       InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     NaiveFileWALManager wal = new NaiveFileWALManager(tmp);
     wal.open(); // create dirs
@@ -253,7 +253,7 @@ public class TestNaiveFileWALManager {
     assertEquals(1, new File(tmp, "error").list().length);
     assertEquals(1, new File(tmp, "logged").list().length);
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
 
   }
 
@@ -262,8 +262,8 @@ public class TestNaiveFileWALManager {
    */
   @Test
   public void testReframeUnframed() throws IOException, InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     NaiveFileWALManager wal = new NaiveFileWALManager(tmp);
     wal.open(); // create dirs
@@ -288,7 +288,7 @@ public class TestNaiveFileWALManager {
     assertEquals(1, new File(tmp, "error").list().length);
     assertEquals(1, new File(tmp, "logged").list().length);
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
 
   }
 
@@ -298,8 +298,8 @@ public class TestNaiveFileWALManager {
   @Test
   public void testReframeBadAckChecksum() throws IOException,
       InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
-    File tmp = BenchmarkHarness.tmpdir;
+    FlumeTestHarness.setupLocalWriteDir();
+    File tmp = FlumeTestHarness.tmpdir;
 
     NaiveFileWALManager wal = new NaiveFileWALManager(tmp);
     wal.open(); // create dirs
@@ -333,7 +333,7 @@ public class TestNaiveFileWALManager {
     assertEquals(1, new File(tmp, "error").list().length);
     assertEquals(1, new File(tmp, "logged").list().length);
 
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
 
   }
 
diff --git a/src/javatest/com/cloudera/flume/collector/TestCollectorSink.java b/src/javatest/com/cloudera/flume/collector/TestCollectorSink.java
index c1311f2..39a662b 100644
--- a/src/javatest/com/cloudera/flume/collector/TestCollectorSink.java
+++ b/src/javatest/com/cloudera/flume/collector/TestCollectorSink.java
@@ -63,7 +63,7 @@ import com.cloudera.flume.handlers.rolling.RollSink;
 import com.cloudera.flume.handlers.rolling.Tagger;
 import com.cloudera.flume.reporter.ReportEvent;
 import com.cloudera.flume.reporter.ReportManager;
-import com.cloudera.util.BenchmarkHarness;
+import com.cloudera.util.FlumeTestHarness;
 import com.cloudera.util.Clock;
 import com.cloudera.util.FileUtil;
 import com.cloudera.util.Pair;
@@ -248,7 +248,7 @@ public class TestCollectorSink {
     // entries). This stubs that out to a call doesn't cause a file not found
     // exception.
     WALManager mockWalMan = mock(WALManager.class);
-    BenchmarkHarness.setupFlumeNode(null, mockWalMan, null, null, null);
+    FlumeTestHarness.setupFlumeNode(null, mockWalMan, null, null, null);
     FlumeNode node = FlumeNode.getInstance();
     File tmpdir = FileUtil.mktempdir();
 
@@ -299,7 +299,7 @@ public class TestCollectorSink {
     snk.close();
 
     FileUtil.rmr(tmpdir);
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
@@ -316,7 +316,7 @@ public class TestCollectorSink {
     // entries). This stubs that out to a call doesn't cause a file not found
     // exception.
     WALManager mockWalMan = mock(WALManager.class);
-    BenchmarkHarness.setupFlumeNode(null, mockWalMan, null, null, null);
+    FlumeTestHarness.setupFlumeNode(null, mockWalMan, null, null, null);
     FlumeNode node = FlumeNode.getInstance();
     File tmpdir = FileUtil.mktempdir();
 
@@ -363,7 +363,7 @@ public class TestCollectorSink {
     snk.close();
 
     FileUtil.rmr(tmpdir);
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
@@ -377,7 +377,7 @@ public class TestCollectorSink {
     // entries). This stubs that out to a call doesn't cause a file not found
     // exception.
     WALManager mockWalMan = mock(WALManager.class);
-    BenchmarkHarness.setupFlumeNode(null, mockWalMan, null, null, null);
+    FlumeTestHarness.setupFlumeNode(null, mockWalMan, null, null, null);
     FlumeNode node = FlumeNode.getInstance();
     File tmpdir = FileUtil.mktempdir();
 
@@ -424,7 +424,7 @@ public class TestCollectorSink {
     snk.close();
 
     FileUtil.rmr(tmpdir);
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   /**
diff --git a/src/javatest/com/cloudera/flume/handlers/avro/TestAvroSinks.java b/src/javatest/com/cloudera/flume/handlers/avro/TestAvroSinks.java
index 473c9a1..b85e387 100644
--- a/src/javatest/com/cloudera/flume/handlers/avro/TestAvroSinks.java
+++ b/src/javatest/com/cloudera/flume/handlers/avro/TestAvroSinks.java
@@ -181,8 +181,8 @@ public class TestAvroSinks implements ExampleData {
             mem.close();
             snk.close();
 
-            sendByteSum.addAndGet(snk.sentBytes.get());
-            LOG.info("sink " + id + " sent " + snk.sentBytes + " bytes");
+            sendByteSum.addAndGet(snk.getSentBytes());
+            LOG.info("sink " + id + " sent " + snk.getSentBytes() + " bytes");
             sendDone.countDown();
 
           } catch (IOException e) {
diff --git a/src/javatest/com/cloudera/flume/handlers/rolling/TestRollRollTags.java b/src/javatest/com/cloudera/flume/handlers/rolling/TestRollRollTags.java
index 121b7e1..2391692 100644
--- a/src/javatest/com/cloudera/flume/handlers/rolling/TestRollRollTags.java
+++ b/src/javatest/com/cloudera/flume/handlers/rolling/TestRollRollTags.java
@@ -36,7 +36,7 @@ import com.cloudera.flume.core.EventSink;
 import com.cloudera.flume.core.MaskDecorator;
 import com.cloudera.flume.handlers.debug.MemorySinkSource;
 import com.cloudera.flume.handlers.endtoend.ValueDecorator;
-import com.cloudera.util.BenchmarkHarness;
+import com.cloudera.util.FlumeTestHarness;
 
 /**
  * This test case demonstrates a usecase where a tag conflict occurs.
@@ -111,7 +111,7 @@ public class TestRollRollTags {
   // should no longer.
   @Test
   public void testAgentCollector() throws FlumeSpecException, IOException, InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
+    FlumeTestHarness.setupLocalWriteDir();
     File path = File.createTempFile("collector", ".tmp");
     path.deleteOnExit();
 
@@ -122,13 +122,13 @@ public class TestRollRollTags {
     snk.open();
     snk.append(e); // should not bork.
     snk.close();
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 
   @Test
   public void testAgentCollectorFixed() throws FlumeSpecException, IOException,
       InterruptedException {
-    BenchmarkHarness.setupLocalWriteDir();
+    FlumeTestHarness.setupLocalWriteDir();
     File path = File.createTempFile("collector", ".tmp");
     path.deleteOnExit();
 
@@ -140,6 +140,6 @@ public class TestRollRollTags {
     snk.open();
     snk.append(e); // should not bork.
     snk.close();
-    BenchmarkHarness.cleanupLocalWriteDir();
+    FlumeTestHarness.cleanupLocalWriteDir();
   }
 }
diff --git a/src/javatest/com/cloudera/util/FlumeTestHarness.java b/src/javatest/com/cloudera/util/FlumeTestHarness.java
new file mode 100644
index 0000000..568ac03
--- /dev/null
+++ b/src/javatest/com/cloudera/util/FlumeTestHarness.java
@@ -0,0 +1,112 @@
+/**
+ * Licensed to Cloudera, Inc. under one
+ * or more contributor license agreements.  See the NOTICE file
+ * distributed with this work for additional information
+ * regarding copyright ownership.  Cloudera, Inc. licenses this file
+ * to you under the Apache License, Version 2.0 (the
+ * "License"); you may not use this file except in compliance
+ * with the License.  You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package com.cloudera.util;
+
+import java.io.File;
+import java.io.IOException;
+
+import org.junit.Assert;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import com.cloudera.flume.agent.FlumeNode;
+import com.cloudera.flume.agent.LivenessManager;
+import com.cloudera.flume.agent.LogicalNodeManager;
+import com.cloudera.flume.agent.MockMasterRPC;
+import com.cloudera.flume.agent.diskfailover.DiskFailoverManager;
+import com.cloudera.flume.agent.diskfailover.NaiveFileFailoverManager;
+import com.cloudera.flume.agent.durability.NaiveFileWALManager;
+import com.cloudera.flume.agent.durability.WALManager;
+import com.cloudera.flume.conf.FlumeConfiguration;
+import com.cloudera.flume.handlers.endtoend.CollectorAckListener;
+import com.cloudera.flume.reporter.ReportManager;
+
+/**
+ * This sets up a batttery of synthetic datasets for testing against different
+ * decorators and sinks. Generally, each test requires ~2GB mem. ~1GB for
+ * keeping a data set in memory and the other GB for some gc headroom.
+ */
+public class FlumeTestHarness {
+  static final Logger LOG = LoggerFactory.getLogger(FlumeTestHarness.class);
+
+  // These are setup to point to new default logging dir for each test.
+  public static FlumeNode node;
+  public static MockMasterRPC mock;
+  public static File tmpdir;
+
+  /**
+   * This sets the log dir in the FlumeConfiguration and then instantiates a
+   * mock master and node that use that configuration
+   */
+  public static void setupLocalWriteDir() {
+    try {
+      tmpdir = FileUtil.mktempdir();
+    } catch (Exception e) {
+      Assert.fail("mk temp dir failed");
+    }
+    FlumeConfiguration conf = FlumeConfiguration.get();
+    conf.clear(); // reset all back to defaults.
+    conf.set(FlumeConfiguration.AGENT_LOG_DIR_NEW, tmpdir.getAbsolutePath());
+
+    mock = new MockMasterRPC();
+    node = new FlumeNode(mock, false /* starthttp */, false /* oneshot */);
+    ReportManager.get().clear();
+  }
+
+  /**
+   * This version allows a particular test case to replace the default
+   * xxxManager with one that is reasonable for the test.
+   * 
+   * Any args that are null will default to the "normal" version.
+   */
+  public static void setupFlumeNode(LogicalNodeManager nodesMan,
+      WALManager walMan, DiskFailoverManager dfMan,
+      CollectorAckListener colAck, LivenessManager liveman) {
+    try {
+      tmpdir = FileUtil.mktempdir();
+    } catch (Exception e) {
+      Assert.fail("mk temp dir failed");
+    }
+    FlumeConfiguration conf = FlumeConfiguration.get();
+    conf.set(FlumeConfiguration.AGENT_LOG_DIR_NEW, tmpdir.getAbsolutePath());
+
+    mock = new MockMasterRPC();
+
+    nodesMan = (nodesMan != null) ? nodesMan : new LogicalNodeManager(NetUtils
+        .localhost());
+    walMan = (walMan != null) ? walMan : new NaiveFileWALManager(new File(conf
+        .getAgentLogsDir()));
+    dfMan = (dfMan != null) ? dfMan : new NaiveFileFailoverManager(new File(
+        conf.getAgentLogsDir()));
+    colAck = (colAck != null) ? colAck : new CollectorAckListener(mock);
+    liveman = (liveman != null) ? liveman : new LivenessManager(nodesMan, mock,
+        walMan);
+
+    node = new FlumeNode(NetUtils.localhost(), mock, nodesMan, walMan, dfMan,
+        colAck, liveman);
+  }
+
+  /**
+   * Cleanup the temp dir after the test is run.
+   */
+  public static void cleanupLocalWriteDir() throws IOException {
+    FileUtil.rmr(tmpdir);
+  }
+
+
+}
-- 
1.7.1

